Index: /anuga_work/production/exmouth_2006/build_exmouth.py
===================================================================
--- /anuga_work/production/exmouth_2006/build_exmouth.py	(revision 4475)
+++ /anuga_work/production/exmouth_2006/build_exmouth.py	(revision 4476)
@@ -69,5 +69,5 @@
 #offshore_dir_name1 = project.offshore_dir_name1
 #offshore_dir_name2 = project.offshore_dir_name2
-
+'''
 # creates DEM from asc data
 print "creates DEMs from asc data"
@@ -79,5 +79,5 @@
 dem2pts(onshore_dir_name, use_cache=True, verbose=True)
 dem2pts(onshore1_dir_name, use_cache=True, verbose=True)
-
+'''
 print'create Geospatial data1 objects from topographies',onshore_dir_name + '.pts'
 G1 = Geospatial_data(file_name = onshore_dir_name + '.pts')
@@ -96,15 +96,18 @@
     mkdir (project.topographies_dir)
 print'export',project.combined_dir_name+'_unclipped' + '.txt'
-G.export_points_file(project.combined_dir_name+ '.txt')
+#G.export_points_file(project.combined_dir_name+ '.txt')
+
+print'create Geospatial data1 objects from topographies',onshore_dir_name + '.pts'
+#G = Geospatial_data(file_name = project.combined_dir_name+ '.txt',verbose=True)
 
 print'split'
-G_small, G_other = G_clipped.split(.10,verbose=True)
+G_small, G_other = G.split(.10,verbose=True)
 
 print 'export', project.combined_small_dir_name + '.txt'
 G_small.export_points_file(project.combined_small_dir_name + '.txt')
 #G_clipped.export_points_file(project.combined_dir_name + '.xya')
+'''
 
 
-'''
 print'project.combined_dir_name + 1.xya',project.combined_dir_name + '1.xya'
 G_all=Geospatial_data(file_name = project.combined_dir_name + '1.xya')
@@ -115,5 +118,5 @@
 print'export 2'
 G_all_2.export_points_file(project.combined_dir_name+'_other1' + '.xya')
-'''
+
 
 #-------------------------------------------------------------------------
@@ -128,10 +131,10 @@
 print 'project.boundaries_dir_name',project.boundaries_dir_name
 
-urs_ungridded2sww(boundaries_in_dir_name, project.boundaries_dir_name,
+urs_ungridded2sww(boundaries_in_dir_name, project.boundaries_in_dir_name,
                   verbose=True, mint=4000, maxt=35000, zscale=1)
+
+'''
 
 
 
 
-
-
Index: /anuga_work/production/exmouth_2006/project.py
===================================================================
--- /anuga_work/production/exmouth_2006/project.py	(revision 4475)
+++ /anuga_work/production/exmouth_2006/project.py	(revision 4476)
@@ -96,5 +96,5 @@
 #combined_dir_name_unclipped1 = topographies_dir + combined_name_unclipped1
 #combined_dir_name1 = topographies_dir + combined_name1
-combined_small_name_dir = topographies_dir + combined_small_name
+combined_small_dir_name = topographies_dir + combined_small_name
 
 meshes_dir = anuga_dir+'meshes'+sep
@@ -107,5 +107,5 @@
 boundaries_name = 'exmouth_3854_17042007'
 
-boundaries_in_dir = anuga_dir+'boundaries'+sep+'urs'+sep+'1_10000'+sep
+boundaries_in_dir = anuga_dir+'boundaries'+sep+'urs'+sep+'dampier'+sep+'1_10000'+sep
 boundaries_in_dir_name = boundaries_in_dir + boundaries_name
 boundaries_dir = anuga_dir+'boundaries'+sep
@@ -133,5 +133,5 @@
 from anuga.utilities.polygon import read_polygon, plot_polygons, polygon_area, is_inside_polygon
 
-poly_all = read_polygon(polygons_dir+'extent_zone50a.csv')
+poly_all = read_polygon(polygons_dir+'extent_more_points.csv')
 
 print 'Area of bounding polygon', polygon_area(poly_all)/1000000.0
@@ -142,22 +142,33 @@
 # Interior region definitions
 ###############################
-'''
-poly_0 = read_polygon(polygons_dir+'neg20_coast_contour_pts.csv')
-res_0 = 20000*res_factor
 
-poly_1 = read_polygon(polygons_dir+'exmouth_north_coast_inside_extent.csv')
-res_1 = 5000*res_factor
 
-poly_2 = read_polygon(polygons_dir+'exmouth_south_coast_inside_extent.csv')
-res_2 = 5000*res_factor
+poly_coast = read_polygon(polygons_dir+'pts_coast.csv')
+res_coast = 10000*res_factor
 
-poly_3 = read_polygon(polygons_dir+'exmouth_town_pts.csv')
-res_3 = 2000*res_factor
+poly_coast1 = read_polygon(polygons_dir+'pts_coast1.csv')
+#res_0 = 20000*res_factor
 
-poly_4 = read_polygon(polygons_dir+'exmouth_inner_town_pts.csv')
-res_4 = 500*res_factor
+poly_coast2 = read_polygon(polygons_dir+'pts_coast2.csv')
+#res_0 = 20000*res_factor
 
-interior_regions = [[poly_0,res_0],[poly_1,res_1],[poly_2,res_2]
-                     ,[poly_3,res_3],[poly_4,res_4]]
+poly_coast3 = read_polygon(polygons_dir+'pts_coast3.csv')
+#res_0 = 20000*res_factor
+
+poly_exmouth = read_polygon(polygons_dir+'pts_exmouth.csv')
+res_exmouth = 500*res_factor
+
+poly_nth_defence = read_polygon(polygons_dir+'pts_nth_defence.csv')
+res_nth_defence = 5000*res_factor
+
+poly_middle = read_polygon(polygons_dir+'pts_middle.csv')
+res_middle = 30000*res_factor
+
+poly_airport = read_polygon(polygons_dir+'pts_airport.csv')
+res_airport = 5000*res_factor
+
+interior_regions = [[poly_coast,res_coast],[poly_coast1,res_coast],[poly_coast2,res_coast]
+                   ,[poly_coast3,res_coast],[poly_middle,res_middle],[poly_exmouth,res_exmouth]
+                   ,[poly_nth_defence,res_nth_defence],[poly_airport,res_airport]]
 
 trigs_min = number_mesh_triangles(interior_regions, poly_all, res_poly_all)
@@ -166,5 +177,5 @@
 
 poly_mainland = read_polygon(polygons_dir+'Initial_Condition.csv')
-'''
+
 ###################################################################
 # Clipping regions for export to asc and regions for clipping data
Index: /anuga_work/production/exmouth_2006/run_exmouth.py
===================================================================
--- /anuga_work/production/exmouth_2006/run_exmouth.py	(revision 4475)
+++ /anuga_work/production/exmouth_2006/run_exmouth.py	(revision 4476)
@@ -2,8 +2,8 @@
 
 Source data such as elevation and boundary data is assumed to be available in
-directories specified by project_urs.py
-The output sww file is stored in project_urs.output_run_time_dir 
-
-The scenario is defined by a triangular mesh created from project_urs.polygon,
+directories specified by project.py
+The output sww file is stored in project.output_run_time_dir 
+
+The scenario is defined by a triangular mesh created from project.polygon,
 the elevation data and a simulated tsunami generated with URS code.
 
@@ -37,15 +37,13 @@
 from anuga.caching import myhash
 # Application specific imports
-import project_urs                 # Definition of file names and polygons
+import project                 # Definition of file names and polygons
 
 def run_model(**kwargs):
     
-    tide = kwargs['tide']
-    alpha = kwargs['alpha']
-    friction = kwargs['friction']
-    time_thinning = kwargs['time_thinning']
+#    tide = kwargs['tide']
+#    alpha = kwargs['alpha']
+#    friction = kwargs['friction']
+#    time_thinning = kwargs['time_thinning']
     scenario_name = kwargs['aa_scenario_name']
-    
-    
     
     #------------------------------------------------------------------------------
@@ -55,22 +53,22 @@
 
     #copy script must be before screen_catcher
-    print 'tide',tide
-    kwargs['est_num_trigs']=project_urs.trigs_min
+    print 'tide',kwargs['tide']
+    kwargs['est_num_trigs']=project.trigs_min
     kwargs['num_cpu']=numprocs
-    kwargs['host']=project_urs.host
-    kwargs['res_factor']=project_urs.res_factor
-    kwargs['starttime']=project_urs.starttime
-    kwargs['yieldstep']=project_urs.yieldstep
-    kwargs['finaltime']=project_urs.finaltime
-    
-    kwargs['output_dir']=project_urs.output_run_time_dir
-    kwargs['bathy_file']=project_urs.combined_dir_name_unclipped1+'.txt'
-#    kwargs['bathy_file']=project_urs.combined_small_dir_name + '.pts'
-    kwargs['boundary_file']=project_urs.boundaries_dir_name + '.sww'
+    kwargs['host']=project.host
+    kwargs['res_factor']=project.res_factor
+    kwargs['starttime']=project.starttime
+    kwargs['yieldstep']=project.yieldstep
+    kwargs['finaltime']=project.finaltime
+    
+    kwargs['output_dir']=project.output_run_time_dir
+    kwargs['bathy_file']=project.combined_dir_name+'.txt'
+#    kwargs['bathy_file']=project.combined_small_dir_name + '.pts'
+    kwargs['boundary_file']=project.boundaries_in_dir_name + '.sww'
 
     print 'output_dir',kwargs['output_dir']
     if myid == 0:
         copy_code_files(kwargs['output_dir'],__file__, 
-                 dirname(project_urs.__file__)+sep+ project_urs.__name__+'.py' )
+                 dirname(project.__file__)+sep+ project.__name__+'.py' )
 
         store_parameters(**kwargs)
@@ -83,8 +81,8 @@
 
     # filenames
-#    meshes_dir_name = project_urs.meshes_dir_name+'.msh'
+#    meshes_dir_name = project.meshes_dir_name+'.msh'
 
     # creates copy of code in output dir
-    print 'min triangles', project_urs.trigs_min,
+    print 'min triangles', project.trigs_min,
     print 'Note: This is generally about 20% less than the final amount'
 
@@ -92,5 +90,5 @@
     # Create the triangular mesh based on overall clipping polygon with a
     # tagged
-    # boundary and interior regions defined in project_urs.py along with
+    # boundary and interior regions defined in project.py along with
     # resolutions (maximal area of per triangle) for each polygon
     #--------------------------------------------------------------------------
@@ -102,14 +100,13 @@
         print 'start create mesh from regions'
 
-        create_mesh_from_regions(project_urs.poly_all,
-                         boundary_tags={'back': [1, 2], 'side': [0,3],
-                                        'ocean': [4]},
-                             maximum_triangle_area=project_urs.res_poly_all,
-                             interior_regions=project_urs.interior_regions,
-                             filename=project_urs.meshes_dir_name+'.msh',
+        create_mesh_from_regions(project.poly_all,
+                         boundary_tags={'back': [3,4,5], 'side': [2,6],
+                                        'ocean': [0,1,7]},
+                             maximum_triangle_area=project.res_poly_all,
+                             interior_regions=project.interior_regions,
+                             filename=project.meshes_dir_name+'.msh',
                              use_cache=False,
                              verbose=True)
     barrier()
-    
 
     #-------------------------------------------------------------------------
@@ -120,5 +117,5 @@
     #domain = cache(Domain, (meshes_dir_name), {'use_cache':True, 'verbose':True}, verbose=True)
     #above don't work
-    domain = Domain(project_urs.meshes_dir_name+'.msh', use_cache=False, verbose=True)
+    domain = Domain(project.meshes_dir_name+'.msh', use_cache=False, verbose=True)
        
     print domain.statistics()
@@ -127,5 +124,4 @@
     kwargs['act_num_trigs']=len(domain)
 
-
     #-------------------------------------------------------------------------
     # Setup initial conditions
@@ -137,8 +133,8 @@
         from polygon import Polygon_function
         #following sets the stage/water to be offcoast only
-        IC = Polygon_function( [(project_urs.poly_mainland, -1.0)], default = tide,
+        IC = Polygon_function( [(project.poly_mainland, -1.0)], default = kwargs['tide'],
                                  geo_reference = domain.geo_reference)
         domain.set_quantity('stage', IC)
-        domain.set_quantity('friction', friction) 
+        domain.set_quantity('friction', kwargs['friction']) 
         
         print 'Start Set quantity'
@@ -148,8 +144,7 @@
                             use_cache = True,
                             verbose = True,
-                            alpha = alpha)
+                            alpha = kwargs['alpha'])
         print 'Finished Set quantity'
     barrier()
-
 
     #------------------------------------------------------
@@ -164,5 +159,5 @@
     #------------------------------------------------------
     print 'domain id', id(domain)
-    domain.set_name(scenario_name)
+    domain.set_name(kwargs['aa_scenario_name'])
     domain.set_datadir(kwargs['output_dir'])
     domain.set_default_order(2) # Apply second order scheme
@@ -180,8 +175,8 @@
     print 'Available boundary tags', domain.get_boundary_tags()
     print 'domain id', id(domain)
-    #print 'Reading Boundary file',project_urs.boundaries_dir_namea + '.sww'
+    #print 'Reading Boundary file',project.boundaries_dir_namea + '.sww'
 
     Bf = Field_boundary(kwargs['boundary_file'],
-                    domain, time_thinning=time_thinning, mean_stage=tide, 
+                    domain, time_thinning=kwargs['time_thinning'], mean_stage=kwargs['tide'], 
                     use_cache=True, verbose=True)
                     
@@ -191,5 +186,5 @@
 
     Br = Reflective_boundary(domain)
-    Bd = Dirichlet_boundary([tide,0,0])
+    Bd = Dirichlet_boundary([kwargs['tide'],0,0])
 
     print'set_boundary'
@@ -237,9 +232,9 @@
 if __name__ == "__main__":
 
-    run_model(file_name=project_urs.home+'detail.csv', aa_scenario_name=project_urs.scenario_name,
-              ab_time=project_urs.time, res_factor= project_urs.res_factor, tide=project_urs.tide, user=project_urs.user,
-              alpha = project_urs.alpha, friction=project_urs.friction,
-              time_thinning = project_urs.time_thinning,
-              dir_comment=project_urs.dir_comment)
-
-
+    run_model(file_name=project.home+'detail.csv', aa_scenario_name=project.scenario_name,
+              ab_time=project.time, res_factor= project.res_factor, tide=project.tide, user=project.user,
+              alpha = project.alpha, friction=project.friction,
+              time_thinning = project.time_thinning,
+              dir_comment=project.dir_comment)
+
+