Index: /anuga_work/production/dampier_2006/export_results.py
===================================================================
--- /anuga_work/production/dampier_2006/export_results.py	(revision 4478)
+++ /anuga_work/production/dampier_2006/export_results.py	(revision 4479)
@@ -5,7 +5,16 @@
 from os import sep
 
-time_dir = '20070419_065050_run' # HAT
-#time_dir = '20070419_065018_run' # MSL
-cellsize = 25
+time_dir = '20070426_045818_run' # HAT 1 in Dampier 10000 yr - CIPMA scenario
+#time_dir = '20070419_065050_run' # HAT 1 in Dampier 10000 yr
+#time_dir = '20070419_065018_run' # MSL 1 in Dampier 10000 yr
+#time_dir = '' # HAT 1 in Broome 10000 yr
+#time_dir = '' # MSL 1 in Broome 10000 yr
+#time_dir = '' # HAT 1 in Pt Hedland 10000 yr
+#time_dir = '' # MSL 1 in Pt Hedland 10000 yr
+#time_dir = '' # HAT 1 in Onslow 10000 yr
+#time_dir = '' # MSL 1 in Onslow 10000 yr
+#time_dir = '' # HAT 1 in Exmouth 10000 yr
+#time_dir = '' # MSL 1 in Exmouth 10000 yr
+cellsize = 20
 timestep = None
 directory = project.output_dir
@@ -17,5 +26,6 @@
 print 'output dir:', name
 
-var = [2,3] # depth and speed
+#var = [2,3] # depth and speed
+var = [3]
 
 for which_var in var:
@@ -50,8 +60,8 @@
                         timestep = timestep,
                         cellsize = cellsize,      
-                        easting_min = project.e_min_area,
-                        easting_max = project.e_max_area,
-                        northing_min = project.n_min_area,
-                        northing_max = project.n_max_area,        
+                        #easting_min = project.e_min_area,
+                        #easting_max = project.e_max_area,
+                        #northing_min = project.n_min_area,
+                        #northing_max = project.n_max_area,        
                         reduction = max, 
                         verbose = True,
@@ -63,8 +73,8 @@
                     timestep = timestep,
                     cellsize = cellsize,      
-                    easting_min = project.e_min_area,
-                    easting_max = project.e_max_area,
-                    northing_min = project.n_min_area,
-                    northing_max = project.n_max_area,        
+                    #easting_min = project.e_min_area,
+                    #easting_max = project.e_max_area,
+                    #northing_min = project.n_min_area,
+                    #northing_max = project.n_max_area,        
                     reduction = max, 
                     verbose = True,
Index: /anuga_work/production/dampier_2006/report/anuga_setup.tex
===================================================================
--- /anuga_work/production/dampier_2006/report/anuga_setup.tex	(revision 4478)
+++ /anuga_work/production/dampier_2006/report/anuga_setup.tex	(revision 4479)
@@ -77,5 +77,5 @@
 \caption{Parameters used in ANUGA for the Dampier scenario.}
 \begin{tabular}{|l|l|l|}\hline
-Mesh & & \hline
+Mesh & & \\ \hline
 & resolution in Region 1 & 500 m$^2$  \\ \hline
 & resolution in Region 2 & 2000 m$^2$ \\ \hline
Index: /anuga_work/production/dampier_2006/report/execsum.tex
===================================================================
--- /anuga_work/production/dampier_2006/report/execsum.tex	(revision 4478)
+++ /anuga_work/production/dampier_2006/report/execsum.tex	(revision 4479)
@@ -3,5 +3,5 @@
 Risk Assessment Methods Project (RAMP). The purpose of this
 study is to determine the potential tsunami inundation extent and 
-particle momentum as the tsunami
+particle speed as the tsunami
 impacts the major gas facilities and infrastructure in Dampier.
 
@@ -10,5 +10,5 @@
 and results (Section \ref{sec:results})
 for a specific tsunami-genic event as it impacts the Dampier gas facilities and infrastructure.
-In particular, maximum inundation and depth and velocity time series are shown 
+In particular, maximum inundation as well as depth and velocity time series are shown 
 for the event occurring at highest astronomical tide. 
 Impact assessments will be conducted by CIPMA and are not discussed here.
Index: /anuga_work/production/dampier_2006/report/mw9_map.tex
===================================================================
--- /anuga_work/production/dampier_2006/report/mw9_map.tex	(revision 4478)
+++ /anuga_work/production/dampier_2006/report/mw9_map.tex	(revision 4479)
@@ -1,8 +1,7 @@
-%\begin{sidewaysfigure}
-
-\begin{figure}
-\centerline{ \includegraphics[scale=0.6]{../report_figures/max_inundation_high_tide.jpg}} 
+\begin{sidewaysfigure}
+%\begin{figure}
+\centerline{ \includegraphics[scale=0.4]{../report_figures/max_inundation_high_tide_v2.jpg}} 
 \caption{Maximum inundation map for the HAT scenario for Dampier region. Data: WA DLI, DPI and AHO.}  
 \label{fig:HAT_max_inundation}
-%\end{sidewaysfigure}
-\end{figure}
+\end{sidewaysfigure}
+%\end{figure}
Index: /anuga_work/production/exmouth_2006/export_results.py
===================================================================
--- /anuga_work/production/exmouth_2006/export_results.py	(revision 4479)
+++ /anuga_work/production/exmouth_2006/export_results.py	(revision 4479)
@@ -0,0 +1,79 @@
+import project, os
+import sys
+
+from anuga.shallow_water.data_manager import sww2dem
+from os import sep
+
+time_dir = '' # HAT 1 in Dampier 10000 yr
+#time_dir = '' # MSL 1 in Dampier 10000 yr
+#time_dir = '' # HAT 1 in Broome 10000 yr
+#time_dir = '' # MSL 1 in Broome 10000 yr
+#time_dir = '' # HAT 1 in Pt Hedland 10000 yr
+#time_dir = '' # MSL 1 in Pt Hedland 10000 yr
+#time_dir = '' # HAT 1 in Onslow 10000 yr
+#time_dir = '' # MSL 1 in Onslow 10000 yr
+#time_dir = '' # HAT 1 in Exmouth 10000 yr
+#time_dir = '' # MSL 1 in Exmouth 10000 yr
+cellsize = 25
+timestep = None
+directory = project.output_dir
+
+name = directory+time_dir+sep+project.scenario_name
+
+is_parallel = True
+if is_parallel == True: nodes = 4
+print 'output dir:', name
+
+var = [2,3] # depth and speed
+
+for which_var in var:
+    if which_var == 0:  # Stage
+        outname = name + '_stage'
+        quantityname = 'stage'
+
+    if which_var == 1:  # Absolute Momentum
+        outname = name + '_momentum_i1'
+        quantityname = '(xmomentum**2 + ymomentum**2)**0.5'  
+
+    if which_var == 2:  # Depth
+        outname = name + '_depth'
+        quantityname = 'stage-elevation'  
+
+    if which_var == 3:  # Speed
+        outname = name + '_speed'
+        quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
+
+    if which_var == 4:  # Elevation
+        outname = name + '_elevation'
+        quantityname = 'elevation'  #Elevation
+
+    if is_parallel == True:
+    #    print 'is_parallel',is_parallel
+        for i in range(0,nodes):
+            namei = name + '_P%d_%d' %(i,nodes)
+            outnamei = outname + '_P%d_%d' %(i,nodes)
+            print 'start sww2dem for sww file %d' %(i)
+            sww2dem(namei, basename_out = outnamei,
+                        quantity = quantityname,
+                        timestep = timestep,
+                        cellsize = cellsize,      
+                        easting_min = project.e_min_area,
+                        easting_max = project.e_max_area,
+                        northing_min = project.n_min_area,
+                        northing_max = project.n_max_area,        
+                        reduction = max, 
+                        verbose = True,
+                        format = 'asc')
+    else:
+        print 'start sww2dem'
+        sww2dem(name, basename_out = outname,
+                    quantity = quantityname,
+                    timestep = timestep,
+                    cellsize = cellsize,      
+                    easting_min = project.e_min_area,
+                    easting_max = project.e_max_area,
+                    northing_min = project.n_min_area,
+                    northing_max = project.n_max_area,        
+                    reduction = max, 
+                    verbose = True,
+                    format = 'asc')
Index: /anuga_work/production/onslow_2006/export_results.py
===================================================================
--- /anuga_work/production/onslow_2006/export_results.py	(revision 4478)
+++ /anuga_work/production/onslow_2006/export_results.py	(revision 4479)
@@ -3,72 +3,77 @@
 
 from anuga.shallow_water.data_manager import sww2dem
-#from anuga.pyvolution.ermapper_grids import read_ermapper_grid
-from anuga.abstract_2d_finite_volumes.util import Screen_Catcher
 from os import sep
 
-#time_dir = '20060704_063005' #HAT
-#time_dir = '20060706_235246' #LAT
-time_dir = '20060704_063234' #MSL
-#time_dir = '20060515_001733' #DTED data
+time_dir = '20070507_215717_run_final_1.5_nbartzis' # HAT 1 in Dampier 10000 yr
+#time_dir = '20070517_061654_run_final_0.0_nbartzis' # MSL 1 in Dampier 10000 yr
+#time_dir = '' # HAT 1 in Broome 10000 yr
+#time_dir = '' # MSL 1 in Broome 10000 yr
+#time_dir = '' # HAT 1 in Pt Hedland 10000 yr
+#time_dir = '' # MSL 1 in Pt Hedland 10000 yr
+#time_dir = '' # HAT 1 in Onslow 10000 yr
+#time_dir = '' # MSL 1 in Onslow 10000 yr
+#time_dir = '' # HAT 1 in Exmouth 10000 yr
+#time_dir = '' # MSL 1 in Exmouth 10000 yr
+cellsize = 25
+timestep = None
 directory = project.outputdir
-name = directory + time_dir +sep + 'source'
-# to develop grid of MOST output
-#directory = project.boundarydir
-#name = directory + project.boundary_basename
+#name = directory + time_dir + sep + project.scenario_name
+name = directory+time_dir+sep+project.scenario_name
 
-#normal screen output is stored in 'outname'
-#screen_output_name = directory + time_dir + sep + "export_output.txt"
-#screen_error_name = directory + time_dir + sep + "export_error.txt"
-# for MOST output
-#screen_output_name = directory  +  "export_output.txt"
-#screen_error_name = directory +  "export_error.txt"
+is_parallel = True
+if is_parallel == True: nodes = 4
+print 'output dir:', name
 
-#used to catch screen output to file
-#sys.stdout = Screen_Catcher(screen_output_name)
-#sys.stderr = Screen_Catcher(screen_error_name)
+var = [2,3,4] # depth and speed
 
-print 'output dir:', name
-#print 'Which variable do you want to export?'
-#which_var = int(raw_input('Stage = 0, Absolute Momentum = 1, Depth = 2, Speed = 3  '  ))
-which_var = 3
-#sys.stderr.write(sys.stdout.data)
-if which_var == 0:  # Stage
-    outname = name + '_stage'
-    quantityname = 'stage'
+for which_var in var:
+    if which_var == 0:  # Stage
+        outname = name + '_stage'
+        quantityname = 'stage'
 
-if which_var == 1:  # Absolute Momentum
-    outname = name + '_momentum'
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5'  #Absolute momentum
+    if which_var == 1:  # Absolute Momentum
+        outname = name + '_momentum_i1'
+        quantityname = '(xmomentum**2 + ymomentum**2)**0.5'  
 
-if which_var == 2:  # Depth
-    outname = name + '_depth'
-    quantityname = 'stage-elevation'  #Depth
+    if which_var == 2:  # Depth
+        outname = name + '_depth'
+        quantityname = 'stage-elevation'  
 
-if which_var == 3:  # Speed
-    outname = name + '_speed'
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
+    if which_var == 3:  # Speed
+        outname = name + '_speed'
+        quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
 
-if which_var == 4:  # Elevation
-    outname = name + '_elevation_25'
-    quantityname = 'elevation'  #Elevation
+    if which_var == 4:  # Elevation
+        outname = name + '_elevation'
+        quantityname = 'elevation'  #Elevation
 
-print 'start sww2dem'
-#sys.stderr.write(sys.stdout.data)
-sww2dem(name, basename_out = outname,
-            quantity = quantityname,
-            cellsize = 25,       
-            # define region for viz purposes
-            easting_min = project.e_min_area,
-            easting_max = project.e_max_area,
-            northing_min = project.n_min_area,
-            northing_max = project.n_max_area,        
-            reduction = max, #this is because we want max quantityname
-            verbose = True,
-            format = 'asc')
-
-#sys.stderr.write(sys.stdout.data)
-
-#Check
-
-#data = read_ermapper_grid(name)
-#print 'Values from %s are in [%f, %f]' %(name, min(data.flat), max(data.flat))
+    if is_parallel == True:
+    #    print 'is_parallel',is_parallel
+        for i in range(0,nodes):
+            namei = name + '_P%d_%d' %(i,nodes)
+            outnamei = outname + '_P%d_%d' %(i,nodes)
+            print 'start sww2dem for sww file %d' %(i)
+            sww2dem(namei, basename_out = outnamei,
+                        quantity = quantityname,
+                        timestep = timestep,
+                        cellsize = cellsize,      
+                        easting_min = project.e_min_area,
+                        easting_max = project.e_max_area,
+                        northing_min = project.n_min_area,
+                        northing_max = project.n_max_area,        
+                        reduction = max, 
+                        verbose = True,
+                        format = 'asc')
+    else:
+        print 'start sww2dem'
+        sww2dem(name, basename_out = outname,
+                    quantity = quantityname,
+                    timestep = timestep,
+                    cellsize = cellsize,      
+                    easting_min = project.e_min_area,
+                    easting_max = project.e_max_area,
+                    northing_min = project.n_min_area,
+                    northing_max = project.n_max_area,        
+                    reduction = max, 
+                    verbose = True,
+                    format = 'asc')
Index: /anuga_work/production/pt_hedland_2006/export_results.py
===================================================================
--- /anuga_work/production/pt_hedland_2006/export_results.py	(revision 4478)
+++ /anuga_work/production/pt_hedland_2006/export_results.py	(revision 4479)
@@ -3,69 +3,78 @@
 
 from anuga.shallow_water.data_manager import sww2dem
-#from anuga.pyvolution.ermapper_grids import read_ermapper_grid
-from anuga.abstract_2d_finite_volumes.util import Screen_Catcher
 from os import sep
 
-#time_dir = '20060706_235036' #test with coarse grid
-time_dir = '20060707_001859' #MSL DLI data
-#time_dir = '20060707_003301' #HAT DLI data
-#time_dir = '20060707_003424' #LAT DLI data
-directory = project.outputdir
-name = directory + time_dir +sep + 'source'
+time_dir = '' # HAT 1 in Dampier 10000 yr
+#time_dir = '' # MSL 1 in Dampier 10000 yr
+#time_dir = '' # HAT 1 in Broome 10000 yr
+#time_dir = '' # MSL 1 in Broome 10000 yr
+#time_dir = '' # HAT 1 in Pt Hedland 10000 yr
+#time_dir = '' # MSL 1 in Pt Hedland 10000 yr
+#time_dir = '' # HAT 1 in Onslow 10000 yr
+#time_dir = '' # MSL 1 in Onslow 10000 yr
+#time_dir = '' # HAT 1 in Exmouth 10000 yr
+#time_dir = '' # MSL 1 in Exmouth 10000 yr
 
+cellsize = 25
+timestep = None
+directory = project.output_dir
 
-#normal screen output is stored in 'outname'
-screen_output_name = directory + time_dir + sep + "export_output_elev.txt"
-screen_error_name = directory + time_dir + sep + "export_error_elev.txt"
+name = directory+time_dir+sep+project.scenario_name
 
-#print 'hello', name
+is_parallel = False
+if is_parallel == True: nodes = 4
+print 'output dir:', name
 
-#used to catch screen output to file
-sys.stdout = Screen_Catcher(screen_output_name)
-sys.stderr = Screen_Catcher(screen_error_name)
+var = [2,3] # depth and speed
 
-print 'output dir:', name
-#print 'Which variable do you want to export?'
-#which_var = int(raw_input('Stage = 0, Absolute Momentum = 1, Depth = 2, Speed = 3  '  ))
-which_var = 4
-#sys.stderr.write(sys.stdout.data)
-if which_var == 0:  # Stage
-    outname = name + '_stage'
-    quantityname = 'stage'
+for which_var in var:
+    if which_var == 0:  # Stage
+        outname = name + '_stage'
+        quantityname = 'stage'
 
-if which_var == 1:  # Absolute Momentum
-    outname = name + '_momentum'
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5'  #Absolute momentum
+    if which_var == 1:  # Absolute Momentum
+        outname = name + '_momentum_i1'
+        quantityname = '(xmomentum**2 + ymomentum**2)**0.5'  
 
-if which_var == 2:  # Depth
-    outname = name + '_depth'
-    quantityname = 'stage-elevation'  #Depth
+    if which_var == 2:  # Depth
+        outname = name + '_depth_facility'
+        quantityname = 'stage-elevation'  
 
-if which_var == 3:  # Speed
-    outname = name + '_speed'
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
+    if which_var == 3:  # Speed
+        outname = name + '_speed_facility'
+        quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
 
-if which_var == 4:  # Elevation
-    outname = name + '_elevation_50'
-    quantityname = 'elevation'  #Elevation
+    if which_var == 4:  # Elevation
+        outname = name + '_elevation'
+        quantityname = 'elevation'  #Elevation
 
-print 'start sww2dem'
-#sys.stderr.write(sys.stdout.data)
-sww2dem(name, basename_out = outname,
-            quantity = quantityname,
-            cellsize = 50,       # Trevor would like this at 25
-            # define region for viz purposes
-            #easting_min = project.e_min_area,
-            #easting_max = project.e_max_area,
-            #northing_min = project.n_min_area,
-            #northing_max = project.n_max_area,        
-            reduction = max, #this is because we want max quantityname
-            verbose = True,
-            format = 'asc')
-
-#sys.stderr.write(sys.stdout.data)
-
-#Check
-
-#data = read_ermapper_grid(name)
-#print 'Values from %s are in [%f, %f]' %(name, min(data.flat), max(data.flat))
+    if is_parallel == True:
+    #    print 'is_parallel',is_parallel
+        for i in range(0,nodes):
+            namei = name + '_P%d_%d' %(i,nodes)
+            outnamei = outname + '_P%d_%d' %(i,nodes)
+            print 'start sww2dem for sww file %d' %(i)
+            sww2dem(namei, basename_out = outnamei,
+                        quantity = quantityname,
+                        timestep = timestep,
+                        cellsize = cellsize,      
+                        easting_min = project.e_min_area,
+                        easting_max = project.e_max_area,
+                        northing_min = project.n_min_area,
+                        northing_max = project.n_max_area,        
+                        reduction = max, 
+                        verbose = True,
+                        format = 'asc')
+    else:
+        print 'start sww2dem'
+        sww2dem(name, basename_out = outname,
+                    quantity = quantityname,
+                    timestep = timestep,
+                    cellsize = cellsize,      
+                    easting_min = project.e_min_area,
+                    easting_max = project.e_max_area,
+                    northing_min = project.n_min_area,
+                    northing_max = project.n_max_area,        
+                    reduction = max, 
+                    verbose = True,
+                    format = 'asc')
Index: /anuga_work/production/shark_bay_2007/export_results.py
===================================================================
--- /anuga_work/production/shark_bay_2007/export_results.py	(revision 4479)
+++ /anuga_work/production/shark_bay_2007/export_results.py	(revision 4479)
@@ -0,0 +1,79 @@
+import project, os
+import sys
+
+from anuga.shallow_water.data_manager import sww2dem
+from os import sep
+
+time_dir = '' # HAT 1 in Dampier 10000 yr
+#time_dir = '' # MSL 1 in Dampier 10000 yr
+#time_dir = '' # HAT 1 in Broome 10000 yr
+#time_dir = '' # MSL 1 in Broome 10000 yr
+#time_dir = '' # HAT 1 in Pt Hedland 10000 yr
+#time_dir = '' # MSL 1 in Pt Hedland 10000 yr
+#time_dir = '' # HAT 1 in Onslow 10000 yr
+#time_dir = '' # MSL 1 in Onslow 10000 yr
+#time_dir = '' # HAT 1 in Exmouth 10000 yr
+#time_dir = '' # MSL 1 in Exmouth 10000 yr
+cellsize = 25
+timestep = None
+directory = project.output_dir
+
+name = directory+time_dir+sep+project.scenario_name
+
+is_parallel = True
+if is_parallel == True: nodes = 4
+print 'output dir:', name
+
+var = [2,3] # depth and speed
+
+for which_var in var:
+    if which_var == 0:  # Stage
+        outname = name + '_stage'
+        quantityname = 'stage'
+
+    if which_var == 1:  # Absolute Momentum
+        outname = name + '_momentum_i1'
+        quantityname = '(xmomentum**2 + ymomentum**2)**0.5'  
+
+    if which_var == 2:  # Depth
+        outname = name + '_depth'
+        quantityname = 'stage-elevation'  
+
+    if which_var == 3:  # Speed
+        outname = name + '_speed'
+        quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
+
+    if which_var == 4:  # Elevation
+        outname = name + '_elevation'
+        quantityname = 'elevation'  #Elevation
+
+    if is_parallel == True:
+    #    print 'is_parallel',is_parallel
+        for i in range(0,nodes):
+            namei = name + '_P%d_%d' %(i,nodes)
+            outnamei = outname + '_P%d_%d' %(i,nodes)
+            print 'start sww2dem for sww file %d' %(i)
+            sww2dem(namei, basename_out = outnamei,
+                        quantity = quantityname,
+                        timestep = timestep,
+                        cellsize = cellsize,      
+                        easting_min = project.e_min_area,
+                        easting_max = project.e_max_area,
+                        northing_min = project.n_min_area,
+                        northing_max = project.n_max_area,        
+                        reduction = max, 
+                        verbose = True,
+                        format = 'asc')
+    else:
+        print 'start sww2dem'
+        sww2dem(name, basename_out = outname,
+                    quantity = quantityname,
+                    timestep = timestep,
+                    cellsize = cellsize,      
+                    easting_min = project.e_min_area,
+                    easting_max = project.e_max_area,
+                    northing_min = project.n_min_area,
+                    northing_max = project.n_max_area,        
+                    reduction = max, 
+                    verbose = True,
+                    format = 'asc')