Index: /anuga_work/production/exmouth_2006/build_exmouth.py
===================================================================
--- /anuga_work/production/exmouth_2006/build_exmouth.py	(revision 4508)
+++ /anuga_work/production/exmouth_2006/build_exmouth.py	(revision 4509)
@@ -27,5 +27,5 @@
 from anuga.shallow_water.data_manager import convert_dem_from_ascii2netcdf, dem2pts
 from anuga.geospatial_data.geospatial_data import *
-from anuga.abstract_2d_finite_volumes.util import start_screen_catcher, copy_code_files
+from anuga.shallow_water.data_manager import start_screen_catcher, copy_code_files
 from anuga_parallel.parallel_abstraction import get_processor_name
 
Index: /anuga_work/production/exmouth_2006/project.py
===================================================================
--- /anuga_work/production/exmouth_2006/project.py	(revision 4508)
+++ /anuga_work/production/exmouth_2006/project.py	(revision 4509)
@@ -11,5 +11,5 @@
 from anuga.utilities.system_tools import get_user_name, get_host_name
 
-codename = 'project.py'
+#codename = 'project.py'
 
 home = getenv('INUNDATIONHOME') + sep +'data'+sep #Sandpit's parent dir   
@@ -17,5 +17,5 @@
 host = get_host_name()
 #needed when running using mpirun, mpirun doesn't inherit umask from .bashrc
-umask(002)
+#umask(002)
 
 #Making assumptions about the location of scenario data
@@ -38,5 +38,5 @@
 starttime=3600
 finaltime=25000
-setup='trial'
+setup='store'
 
 if setup =='trial':
@@ -55,4 +55,10 @@
     time_thinning=1
     yieldstep=60
+if setup =='store':
+    print'store'
+    res_factor=10
+    time_thinning=48
+    yieldstep=240    
+
 
 dir_comment='_'+setup+'_'+str(tide)+'_'+str(user)
Index: /anuga_work/production/exmouth_2006/run_exmouth.py
===================================================================
--- /anuga_work/production/exmouth_2006/run_exmouth.py	(revision 4508)
+++ /anuga_work/production/exmouth_2006/run_exmouth.py	(revision 4509)
@@ -33,5 +33,5 @@
 
 from anuga.pmesh.mesh_interface import create_mesh_from_regions
-from anuga.abstract_2d_finite_volumes.util import start_screen_catcher, copy_code_files,store_parameters
+from anuga.shallow_water.data_manager import start_screen_catcher, copy_code_files,store_parameters
 from anuga_parallel.parallel_api import distribute, numprocs, myid, barrier
 from anuga_parallel.parallel_abstraction import get_processor_name
@@ -65,5 +65,5 @@
     kwargs['output_dir']=project.output_run_time_dir
     kwargs['bathy_file']=project.combined_dir_name+'.txt'
-#    kwargs['bathy_file']=project.combined_small_dir_name + '.pts'
+#    kwargs['bathy_file']=project.combined_small_dir_name + '.txt'
     kwargs['boundary_file']=project.boundaries_in_dir_name + '.sww'
 
@@ -246,5 +246,5 @@
     swwfile = kwargs['output_dir']+kwargs['aa_scenario_name']+'.sww'
     buildings_filename = project.buildings_filename
-    buildings_filename_out = file_loc + project.buildings_filename_out
+    buildings_filename_out = project.buildings_filename_out
                 
     inundation_damage(swwfile, buildings_filename, buildings_filename_out)
Index: /anuga_work/production/exmouth_2006/run_store.py
===================================================================
--- /anuga_work/production/exmouth_2006/run_store.py	(revision 4509)
+++ /anuga_work/production/exmouth_2006/run_store.py	(revision 4509)
@@ -0,0 +1,101 @@
+"""Script for running tsunami inundation scenario for Dampier, WA, Australia.
+
+Source data such as elevation and boundary data is assumed to be available in
+directories specified by project.py
+The output sww file is stored in project.output_run_time_dir 
+
+The scenario is defined by a triangular mesh created from project.polygon,
+the elevation data and a simulated tsunami generated with URS code.
+
+Ole Nielsen and Duncan Gray, GA - 2005 and Jane Sexton, Nick Bartzis, GA - 2006
+"""
+
+#------------------------------------------------------------------------------
+# Import necessary modules
+#------------------------------------------------------------------------------
+
+# Standard modules
+from os import sep
+from os.path import dirname, basename
+from os import mkdir, access, F_OK
+from shutil import copy
+import time
+import sys
+
+# Related major packages
+from anuga.shallow_water import Domain
+from anuga.shallow_water import Dirichlet_boundary
+from anuga.shallow_water import File_boundary
+from anuga.shallow_water import Reflective_boundary
+from anuga.shallow_water import Field_boundary
+from Numeric import allclose
+
+from anuga.pmesh.mesh_interface import create_mesh_from_regions
+from anuga.abstract_2d_finite_volumes.util import start_screen_catcher, copy_code_files,store_parameters
+from anuga_parallel.parallel_api import distribute, numprocs, myid, barrier
+from anuga_parallel.parallel_abstraction import get_processor_name
+from anuga.caching import myhash
+# Application specific imports
+import project                 # Definition of file names and polygons
+
+def run_model(**kwargs):
+    
+#    tide = kwargs['tide']
+#    alpha = kwargs['alpha']
+#    friction = kwargs['friction']
+#    time_thinning = kwargs['time_thinning']
+    scenario_name = kwargs['aa_scenario_name']
+    
+    #------------------------------------------------------------------------------
+    # Copy scripts to time stamped output directory and capture screen
+    # output to file
+    #------------------------------------------------------------------------------
+    '''
+    #copy script must be before screen_catcher
+    print 'tide',tide
+    kwargs['est_num_trigs']=444444
+    kwargs['num_cpu']=numprocs
+    kwargs['host']=project.host
+    kwargs['res_factor']=project.res_factor
+    kwargs['starttime']=project.starttime
+    kwargs['yieldstep']=project.yieldstep
+    kwargs['finaltime']=project.finaltime
+'''    
+    kwargs['output_dir']=project.output_run_time_dir
+    kwargs['bathy_file']=project.combined_dir_name+'.txt'
+    kwargs['boundary_file']=project.boundaries_dir_name + '.sww'
+    
+    print 'output_dir',kwargs['output_dir']
+    if myid == 0:
+        copy_code_files(kwargs['output_dir'],__file__, 
+                 dirname(project.__file__)+sep+ project.__name__+'.py' )
+
+        store_parameters(**kwargs)
+
+    barrier()
+
+    start_screen_catcher(kwargs['output_dir'], myid, numprocs)
+    '''
+  
+    kwargs['act_num_trigs']=7777777
+
+    kwargs['input_start_time']=666
+    #kwargs 'completed' must be added to write the final parameters to file
+    '''   
+    kwargs['completed']=6
+    if myid == 0:
+        store_parameters(**kwargs)
+    barrier()
+
+
+#-------------------------------------------------------------
+if __name__ == "__main__":
+
+    run_model(file_name=project.home+'detail_test.csv', aa_scenario_name='test_store_parameters',
+              ab_time=project.time, res_factor= project.res_factor,
+#               tide=project.tide, user=project.user,
+#              alpha = project.alpha, friction=project.friction,
+#              time_thinning = project.time_thinning,
+              dir_comment=project.dir_comment)
+
+